searchNodes=[{"doc":"Functions for interacting with Solana's Token Swap Program .","ref":"Solana.SPL.TokenSwap.html","title":"Solana.SPL.TokenSwap","type":"module"},{"doc":"The size of a serialized token swap account.","ref":"Solana.SPL.TokenSwap.html#byte_size/0","title":"Solana.SPL.TokenSwap.byte_size/0","type":"function"},{"doc":"Creates the instructions to deposit A or B tokens into the pool. Options :swap - Required. The token swap to use. :authority - Required. the swap account's swap authority. :user_token - Required. The user's account for token A or B . :swap_a - Required. The swap account for token A . :swap_b - Required. The swap account for token B . :user_pool - Required. The user's account for the pool token. Pool tokens will be deposited here. :pool_mint - Required. The swap pool token's mint. :user_authority - Required. Account delegated to transfer the user's tokens. :amount - Required. Amount of token A or B to deposit. :amount_pool - Required. Minimum amount of pool tokens to mint.","ref":"Solana.SPL.TokenSwap.html#deposit/1","title":"Solana.SPL.TokenSwap.deposit/1","type":"function"},{"doc":"Creates the instructions to deposit both A and B tokens into the pool. Options :swap - Required. The token swap to use. :authority - Required. the swap account's swap authority. :user_a - Required. The user's account for token A . :user_b - Required. The user's account for token B . :swap_a - Required. The swap account for token A . :swap_b - Required. The swap account for token B . :user_pool - Required. The user's account for the pool token. Pool tokens will be deposited here. :pool_mint - Required. The swap pool token's mint. :user_authority - Required. Account delegated to transfer the user's tokens. :amount_a - Required. Maximum amount of token A to deposit. :amount_b - Required. Maximum amount of token B to deposit. :amount_pool - Required. Amount of pool tokens to mint.","ref":"Solana.SPL.TokenSwap.html#deposit_all/1","title":"Solana.SPL.TokenSwap.deposit_all/1","type":"function"},{"doc":"Translates the result of a Solana.RPC.Request.get_account_info/2 into token swap account information.","ref":"Solana.SPL.TokenSwap.html#from_account_info/1","title":"Solana.SPL.TokenSwap.from_account_info/1","type":"function"},{"doc":"The Token Swap Program's ID.","ref":"Solana.SPL.TokenSwap.html#id/0","title":"Solana.SPL.TokenSwap.id/0","type":"function"},{"doc":"Creates the instructions to initialize a new token swap account. Options :payer - Required. The account that will pay for the token swap account creation. :balance - Required. The lamport balance the token swap account should have. :authority - Required. The token swap account's swap authority :new - Required. The public key of the newly-created token swap account. :token_a - Required. The A token account in token swaps. Must be owned by authority . :token_b - Required. The B token account in token swaps. Must be owned by authority . :pool - Required. The token account which holds outside liquidity and enables A/B trades. :pool_mint - Required. The mint of the pool . :fee_account - Required. The token account which receives all trading and withdrawal fees. :trade_fee - The new swap account's trading fee. Trade fees are extra token amounts that are held inside the token accounts during a trade, making the value of liquidity tokens rise. The default value is {0, 1} . :owner_trade_fee - The new swap account's owner trading fee. Owner trading fees are extra token amounts that are held inside the token accounts during a trade, with the equivalent in pool tokens minted to the owner of the program. The default value is {0, 1} . :owner_withdraw_fee - The new swap account's owner withdraw fee. Owner withdraw fees are extra liquidity pool token amounts that are sent to the owner on every withdrawal. The default value is {0, 1} . :host_fee - The new swap account's host fee. Host fees are a proportion of the owner trading fees, sent to an extra account provided during the trade. The default value is {0, 1} . :curve - Required. The automated market maker (AMM) curve to use for the new token swap account. Should take the form {type, params} . See the docs on which curves are available.","ref":"Solana.SPL.TokenSwap.html#init/1","title":"Solana.SPL.TokenSwap.init/1","type":"function"},{"doc":"Creates the instructions to swap token A for token B or vice versa. Options :swap - Required. The token swap to use. :authority - Required. the swap account's swap authority. :user_source - Required. User's source token account. Must have the same mint as swap_source . :swap_source - Required. swap source token account. Must have the same mint as user_source . :user_destination - Required. User's destination token account. Must have the same mint as swap_destination . :swap_destination - Required. swap destination token account. Must have the same mint as user_destination . :pool_mint - Required. The swap pool token's mint. :fee_account - Required. The token account which receives all trading and withdrawal fees. :host_fee_account - Host account to gather fees. :user_authority - Required. Account delegated to transfer the user's tokens. :amount - Required. Amount to transfer from the source account. :minimum_return - Required. Minimum number of tokens the user will receive.","ref":"Solana.SPL.TokenSwap.html#swap/1","title":"Solana.SPL.TokenSwap.swap/1","type":"function"},{"doc":"Creates the instructions to withdraw A or B tokens from the pool. Options :swap - Required. The token swap to use. :authority - Required. the swap account's swap authority. :user_token - Required. The user's account for token A or B . :swap_a - Required. The swap account for token A . :swap_b - Required. The swap account for token B . :user_pool - Required. The user's account for the pool token. Pool tokens with be withdrawn from here. :pool_mint - Required. The swap pool token's mint. :user_authority - Required. Account delegated to transfer the user's tokens. :fee_account - Required. The token account which receives all trading and withdrawal fees. :amount - Required. Amount of token A or B to withdraw. :amount_pool - Required. Maximum amount of pool tokens to burn.","ref":"Solana.SPL.TokenSwap.html#withdraw/1","title":"Solana.SPL.TokenSwap.withdraw/1","type":"function"},{"doc":"Creates the instructions to withdraw both A and B tokens from the pool. Options :swap - Required. The token swap to use. :authority - Required. the swap account's swap authority. :user_a - Required. The user's account for token A . :user_b - Required. The user's account for token B . :swap_a - Required. The swap account for token A . :swap_b - Required. The swap account for token B . :user_pool - Required. The user's account for the pool token. Pool tokens with be withdrawn from here. :pool_mint - Required. The swap pool token's mint. :user_authority - Required. Account delegated to transfer the user's tokens. :fee_account - Required. The token account which receives all trading and withdrawal fees. :amount_a - Required. Minimum amount of token A to withdraw. :amount_b - Required. Minimum amount of token B to withdraw. :amount_pool - Required. Amount of pool tokens to burn.","ref":"Solana.SPL.TokenSwap.html#withdraw_all/1","title":"Solana.SPL.TokenSwap.withdraw_all/1","type":"function"},{"doc":"Functions for interacting with the Associated Token Account Program . An associated token account's address is derived from a user's main system account and the token mint, which means each user can only have one associated token account per token.","ref":"Solana.SPL.AssociatedToken.html","title":"Solana.SPL.AssociatedToken","type":"module"},{"doc":"Creates an associated token account. This will be owned by the owner regardless of who actually creates it. Options :payer - Required. The account which will pay for the new account's creation :owner - Required. The account which will own the new account :new - Required. Public key of the associated token account to create :mint - Required. The mint of the new account","ref":"Solana.SPL.AssociatedToken.html#create_account/1","title":"Solana.SPL.AssociatedToken.create_account/1","type":"function"},{"doc":"Finds the token account address associated with a given owner and mint. This address will be unique to the mint/owner combination.","ref":"Solana.SPL.AssociatedToken.html#find_address/2","title":"Solana.SPL.AssociatedToken.find_address/2","type":"function"},{"doc":"The Associated Token Account's Program ID","ref":"Solana.SPL.AssociatedToken.html#id/0","title":"Solana.SPL.AssociatedToken.id/0","type":"function"},{"doc":"Functions for interacting with Solana's Token Program .","ref":"Solana.SPL.Token.html","title":"Solana.SPL.Token","type":"module"},{"doc":"Creates an instruction to approves a delegate. A delegate is given the authority over tokens on behalf of the source account's owner. If you want to check the token's mint and decimals , set the checked? option to true and provide the mint and decimals options. Options :source - Required. The account to send tokens from :delegate - Required. The account authorized to perform a transfer of tokens from source :owner - Required. The account which owns source :multi_signers - signing accounts if the owner is a Solana.SPL.Token.MultiSig account :amount - Required. The maximum number of tokens that delegate can send on behalf of source :checked? - whether or not to check the token mint and decimals; may be useful when creating transactions offline or within a hardware wallet. The default value is false . :decimals - The number of decimals in the amount . Only used if checked? is true. :mint - The mint account for from and to . Only used if checked? is true.","ref":"Solana.SPL.Token.html#approve/1","title":"Solana.SPL.Token.approve/1","type":"function"},{"doc":"Creates an instruction to burn tokens by removing them from an account. burn/1 does not support accounts associated with the native mint, use close_account/1 instead. If you want to check the token's mint and decimals , set the checked? option to true and provide the decimals option. Options :token - Required. The token account which will have its tokens burned :mint - Required. The mint account which will burn the tokens :owner - Required. the owner of token :amount - Required. amount of tokens to burn :multi_signers - signing accounts if the owner is a Solana.SPL.Token.MultiSig account :checked? - whether or not to check the token mint and decimals; may be useful when creating transactions offline or within a hardware wallet. The default value is false . :decimals - The number of decimals in the amount . Only used if checked? is true.","ref":"Solana.SPL.Token.html#burn/1","title":"Solana.SPL.Token.burn/1","type":"function"},{"doc":"The size of a serialized token account.","ref":"Solana.SPL.Token.html#byte_size/0","title":"Solana.SPL.Token.byte_size/0","type":"function"},{"doc":"Creates an instruction to close an account by transferring all its SOL to the destination account. A non-native account may only be closed if its token amount is zero. Options :to_close - Required. The account to close :destination - Required. The account which will receive the remaining balance of to_close :authority - Required. the account close authority for to_close :multi_signers - signing accounts if the authority is a Solana.SPL.Token.MultiSig account","ref":"Solana.SPL.Token.html#close_account/1","title":"Solana.SPL.Token.close_account/1","type":"function"},{"doc":"Creates an instruction to freeze an initialized account using the mint's freeze_authority (if set). Options :to_freeze - Required. The account to freeze :mint - Required. The mint account for to_freeze :authority - Required. the freeze authority for mint :multi_signers - signing accounts if the authority is a Solana.SPL.Token.MultiSig account","ref":"Solana.SPL.Token.html#freeze/1","title":"Solana.SPL.Token.freeze/1","type":"function"},{"doc":"Translates the result of a Solana.RPC.Request.get_account_info/2 into a Solana.SPL.Token.t/0 .","ref":"Solana.SPL.Token.html#from_account_info/1","title":"Solana.SPL.Token.from_account_info/1","type":"function"},{"doc":"The Token Program's ID.","ref":"Solana.SPL.Token.html#id/0","title":"Solana.SPL.Token.id/0","type":"function"},{"doc":"Creates the instructions which initialize a new account to hold tokens. If this account is associated with the native mint then the token balance of the initialized account will be equal to the amount of SOL in the account. If this account is associated with another mint, that mint must be initialized before this command can succeed. All instructions must be executed as part of the same transaction. Otherwise another party can acquire ownership of the uninitialized account. Options :payer - Required. The account that will pay for the token account creation :balance - Required. The lamport balance the token account should have :mint - Required. The mint of the newly-created token account :owner - Required. The owner of the newly-created token account :new - Required. The public key of the newly-created token account","ref":"Solana.SPL.Token.html#init/1","title":"Solana.SPL.Token.init/1","type":"function"},{"doc":"Creates an instruction to mints new tokens to an account. The native mint does not support minting. If you want to check the token's mint and decimals , set the checked? option to true and provide the decimals option. Options :token - Required. The token account which will receive the minted tokens :mint - Required. The mint account which will mint the tokens :authority - Required. the current mint authority :amount - Required. amount of tokens to mint :multi_signers - signing accounts if the authority is a Solana.SPL.Token.MultiSig account :checked? - whether or not to check the token mint and decimals; may be useful when creating transactions offline or within a hardware wallet. The default value is false . :decimals - The number of decimals in the amount . Only used if checked? is true.","ref":"Solana.SPL.Token.html#mint_to/1","title":"Solana.SPL.Token.mint_to/1","type":"function"},{"doc":"Creates an instruction to revoke a previously approved delegate's authority to make transfers. Options :source - Required. The account to send tokens from :owner - Required. The account which owns source :multi_signers - signing accounts if the owner is a Solana.SPL.Token.MultiSig account","ref":"Solana.SPL.Token.html#revoke/1","title":"Solana.SPL.Token.revoke/1","type":"function"},{"doc":"Creates an instruction to set a new authority for a mint or account. Options :account - Required. The account which will change authority, either a mint or token account :authority - Required. the current authority for mint_or_token :new_authority - the new authority for mint_or_token :type - Required. type of authority to set :multi_signers - signing accounts if the authority is a Solana.SPL.Token.MultiSig account","ref":"Solana.SPL.Token.html#set_authority/1","title":"Solana.SPL.Token.set_authority/1","type":"function"},{"doc":"Creates an instruction to thaw a frozen account using the mint's freeze_authority (if set). Options :to_thaw - Required. The account to thaw :mint - Required. The mint account for to_thaw :authority - Required. the freeze authority for mint :multi_signers - signing accounts if the authority is a Solana.SPL.Token.MultiSig account","ref":"Solana.SPL.Token.html#thaw/1","title":"Solana.SPL.Token.thaw/1","type":"function"},{"doc":"Creates an instruction to transfer tokens from one account to another either directly or via a delegate. If this account is associated with the native mint then equal amounts of SOL and Tokens will be transferred to the destination account. If you want to check the token's mint and decimals , set the checked? option to true and provide the mint and decimals options. Options :from - Required. The account to send tokens from :to - Required. The account to receive tokens :owner - Required. The owner of from :multi_signers - signing accounts if the owner is a Solana.SPL.Token.MultiSig account :amount - Required. The number of tokens to send :checked? - whether or not to check the token mint and decimals; may be useful when creating transactions offline or within a hardware wallet. The default value is false . :decimals - The number of decimals in the amount . Only used if checked? is true. :mint - The mint account for from and to . Only used if checked? is true.","ref":"Solana.SPL.Token.html#transfer/1","title":"Solana.SPL.Token.transfer/1","type":"function"},{"doc":"Token account metadata.","ref":"Solana.SPL.Token.html#t:t/0","title":"Solana.SPL.Token.t/0","type":"type"},{"doc":"Functions for interacting with the mint accounts of Solana's Token Program .","ref":"Solana.SPL.Token.Mint.html","title":"Solana.SPL.Token.Mint","type":"module"},{"doc":"The size of a serialized token mint account.","ref":"Solana.SPL.Token.Mint.html#byte_size/0","title":"Solana.SPL.Token.Mint.byte_size/0","type":"function"},{"doc":"Translates the result of a Solana.RPC.Request.get_account_info/2 into a Solana.SPL.Token.Mint.t/0 .","ref":"Solana.SPL.Token.Mint.html#from_account_info/1","title":"Solana.SPL.Token.Mint.from_account_info/1","type":"function"},{"doc":"Genereates the instructions to initialize a mint account. Options :payer - Required. The account that will pay for the mint creation :balance - Required. The lamport balance the mint account should have :decimals - Required. decimals for the new mint :authority - Required. authority for the new mint :freeze_authority - freeze authority for the new mint :new - Required. public key for the new mint","ref":"Solana.SPL.Token.Mint.html#init/1","title":"Solana.SPL.Token.Mint.init/1","type":"function"},{"doc":"Token Program mint account metadata.","ref":"Solana.SPL.Token.Mint.html#t:t/0","title":"Solana.SPL.Token.Mint.t/0","type":"type"},{"doc":"Functions for dealing with multi-signature accounts. Multi-signature accounts can used in place of any single owner/delegate accounts in any token instruction that require an owner/delegate to be present.","ref":"Solana.SPL.Token.MultiSig.html","title":"Solana.SPL.Token.MultiSig","type":"module"},{"doc":"The size of a serialized multi-signature account.","ref":"Solana.SPL.Token.MultiSig.html#byte_size/0","title":"Solana.SPL.Token.MultiSig.byte_size/0","type":"function"},{"doc":"Translates the result of a Solana.RPC.Request.get_account_info/2 into a Solana.SPL.Token.MultiSig.t/0 .","ref":"Solana.SPL.Token.MultiSig.html#from_account_info/1","title":"Solana.SPL.Token.MultiSig.from_account_info/1","type":"function"},{"doc":"Creates the instructions to initialize a multisignature account. These instructions must be included in the same Transaction. Options :payer - Required. The account that will pay for the multisig creation :balance - Required. The lamport balance the multisig account should have :signers - Required. The full set of signers; should be a list of 11 members or fewer :signatures_required - Required. number of signatures required; should be between 1 and 11 (inclusive) :new - Required. public key for the new multisig account","ref":"Solana.SPL.Token.MultiSig.html#init/1","title":"Solana.SPL.Token.MultiSig.init/1","type":"function"},{"doc":"Multi-signature account metadata.","ref":"Solana.SPL.Token.MultiSig.html#t:t/0","title":"Solana.SPL.Token.MultiSig.t/0","type":"type"},{"doc":"The unofficial Elixir package for interacting with the Solana Program Library . Note that this README refers to the master branch of solana_spl , not the latest released version on Hex. See the documentation for the documentation of the version you're using.","ref":"readme.html","title":"Solana.SPL","type":"extras"},{"doc":"Add solana_spl to your list of dependencies in mix.exs : def deps do [ { :solana_spl , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Solana.SPL - Installation","type":"extras"},{"doc":"TODO. For now, the solana package docs contain everything you need to know to use solana_spl .","ref":"readme.html#usage-guidelines","title":"Solana.SPL - Usage Guidelines","type":"extras"},{"doc":"This library implements instructions and tests for the following programs: [x] Token Program : Solana.SPL.Token [x] Associated Token Account Program : Solana.SPL.AssociatedToken [x] Token Swap Program : Solana.SPL.TokenSwap","ref":"readme.html#list-of-programs","title":"Solana.SPL - List of Programs","type":"extras"},{"doc":"Copyright © 2021 Derek Meer Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]